(use-modules (srfi srfi-1) (srfi srfi-13); to use in modules
	     
	     
	     (alterator str)
	     (alterator object)
	     (alterator help)
	     (alterator gettext)
	     (alterator glob)
	     (alterator algo)
	     (alterator sandbox)
	     (alterator command)
	     
	     (alterator lookout common)
	     (alterator lookout woo)
	     (alterator lookout context)
	     (alterator lookout globals)
	     (alterator lookout events)
	     (alterator lookout goto)
	     (alterator lookout atlas)
	     (alterator lookout widgets)
	     (alterator lookout popup)
	     (alterator lookout document))

(define-operation call)

(define (dbus-handler sender destination interface dmember . args)
  (let ((current-dialog (from-context 'popup)))
    (and current-dialog
	 (call current-dialog 'on-dbus
			 sender
			 destination
			 interface
			 dmember
			 args))))

(define-macro (declare-application-constructor <func>)
    `(define lookout-make-application ,<func>))

(define-macro (declare-application-destructor <func>)
     `(define lookout-delete-application ,<func>))

(define-macro (declare-application-runner <func>)
     `(define lookout-exec-application ,<func>))




;;;;;;;;;;;;wait-message support

(define (with-splash-message thunk)
  (let* ((splash (splashscreen))
	 (sp (cadr splash)))
    (with-changed-context 'splash sp
			  (dynamic-wind
			    (lambda()
			      ((caddr splash) #f)) ;initialize screen
			    thunk
			    (lambda()
			      (delete sp))))))

(define (splash-message msg)
  (set (from-context 'splash) 'message msg))

(define (splash-image img)
  ((from-context 'splash) pixmap img))

(define *lookout-default-driver* "qt")

(define (lookout . rest)
  (let ((driver (if (null? rest) *lookout-default-driver* (car rest)))
        (opts   (if (null? rest) rest (cdr rest))))
    (load (string-append datadir "lookout-" driver ".scm"))
    (let ((app (apply lookout-make-application opts)))
      (lookout-exec-application)
      (lookout-delete-application app))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(declare-event-callback on-click)
(declare-event-callback on-double-click)
(declare-event-callback on-change)
(declare-event-callback on-return)
(declare-event-callback on-select)
(declare-event-callback on-toggle)
(declare-event-callback on-dbus sender destination interface dmember args)
(declare-event-callback on-destroy)
(declare-event-callback on-goto url)
(declare-event-callback on-before-goto url)

